var DragManager = function(handler, operator){
	this.registedDragElements = [];
	this.activeEle = null;
	this.initEvent();
};

DragManager.prototype = {
	initEvent: function(){
		var dragEles = this.registedDragElements;
		var activeEle = null;
		dkit.addEvent(document, 'mousemove', function(e){
			if(activeEle){
				activeEle.refreshPosition(e.clientX, e.clientY);
			}
		});
		dkit.addEvent(document, 'mouseup', function(e){
			if(activeEle){
				activeEle.stopDrag();
				activeEle = null;
			}
		});
		dkit.addEvent(document, 'mousedown', function(e){
			var target = e.target;
			//console.log(target);
			for(var i = 0, len = dragEles.length; i < len; i ++){
				var dragEle = dragEles[i];
				//console.log(dragEle.handler);
				if(target == dragEle.handler){
					activeEle = dragEle;
					dragEle.initStartPosition(e.clientX, e.clientY);
					dragEle.startDrag();
				}
			}
			
		});
	},
	regist: function(handler, operator){
		dkit.$$(handler).css('cursor', 'move');
		this.registedDragElements.push(new DragElement(handler, operator));
	}
	
};

var DragElement = function(handler, operator){
	this.handler = handler;
	this.operator = operator;
	this.startX = NaN;
	this.startY = NaN;
	this.startLeft = NaN;
	this.startTop = NaN;
	this.dragStatus = false;
	this.handler.style['MozUserSelect'] = 'none';
};

DragElement.prototype = {
	initStartPosition: function(_x, _y){
		this.startX = _x;
		this.startY = _y;
		this.startLeft = this.operator.offsetLeft;
		this.startTop = this.operator.offsetTop;
	},
	startDrag: function(){
		this.dragStatus = true;
	},
	stopDrag: function(){
		this.dragStatus = false;
	},
	refreshPosition: function(_x, _y){
		if(!this.dragStatus){
			return;
		}
		this.operator.style.left = this.startLeft + _x - this.startX + 'px';
		this.operator.style.top = this.startTop + _y - this.startY + 'px';
	}
};
